#extension GL_ARB_texture_rectangle : enable

//attribute  vec3  gl_Vertex;           // Sprite center world position
//attribute  vec2  gl_MultiTexCoord0;   // Sprite texture coordinates

uniform sampler2DRect Texture;
uniform vec3          Param;  // (texture inv size x, texture inv size y, radius)

#ifdef _VERTEX_

out vec2  TexCoord;
out vec3  Color;

void main()
{
    vec4  viewPos = gl_ModelViewMatrix * gl_Vertex;
    TexCoord = gl_MultiTexCoord0.xy;
    viewPos.xy += Param.z * (TexCoord * Param.xy - vec2(1.0));
    gl_Position = gl_ProjectionMatrix * viewPos;
}

#else

in vec2  TexCoord;
in vec3  Color;

void main()
{
    gl_FragColor = texture2DRect(Texture, TexCoord);
}

#endif
