#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect   Scene;
uniform vec2            BlackHolePos;
uniform vec4            Param; // (2/fbo.W, 2/fbo.H, size, 1.0f/0.0041f)

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

void main()
{
    vec2  texCoord = gl_TexCoord[0].xy * Param.xy - vec2(1.0);
    float r = length(texCoord);

    if (r < 0.99)
    {
        vec3  norm = normalize(vec3(texCoord / r, Param.w * sqrt(r)));
        vec3  distort = refract(vec3(0,0,1), norm, 42); // 2.6
        float fade = clamp((0.99 - r) / 0.99, 0, 1);
        texCoord += distort.xy * fade * fade;
        gl_FragColor.a = 0;
    }
    else
        gl_FragColor.a = 1;

    gl_FragColor.rgb = texture2DRect(Scene, BlackHolePos + texCoord * Param.z).rgb;
}

#endif
