//attribute  vec3  gl_Vertex;           // Sprite center world position
//attribute  vec4  gl_Color;            // Sprite color, Sprite vertex Id
//attribute  vec2  gl_MultiTexCoord0;   // 1/Radius, Luminosity

uniform vec3  Param;    // StarBrightMin, StarParticleFadeOut, StarPointParticleSize
uniform vec3  Param2;   // PlanMaxParticleRadius_pix, 1.0 / (PlanMaxParticleRadius_pix - 1.0), cam.PixelSize

#ifdef _VERTEX_

out vec4  Color;

void main()
{
    vec4 viewPos = gl_ModelViewMatrix * gl_Vertex;
    gl_Position = gl_ProjectionMatrix * viewPos;

    float Dist2 = dot(viewPos.xyz, viewPos.xyz);
    float mag = gl_MultiTexCoord0.y;

    float RadiusPix = gl_MultiTexCoord0.x / sqrt(Dist2) * Param2.z;
    float fade = clamp(Param.y*(mag - Param.x), 0.0, 1.0) *
                 clamp((Param2.x - RadiusPix) * Param2.y, 0.0, 1.0);

    Color = vec4(gl_Color.rgb * fade, fade);

    if (mag > 1.0)  mag = 1.0 + log(mag);
    gl_PointSize = Param.z * sqrt(mag);
}

#else

in vec4  Color;

void main()
{
    gl_FragColor = Color;
}

#endif
