uniform sampler2D BumpMap;
uniform vec3      Scale;

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

void main()
{
    vec2 dx = vec2(Scale.x, 0.0);
    vec2 dy = vec2(0.0, Scale.y);

    float h  = texture2D(BumpMap, gl_TexCoord[0].xy).r;
    float pc = h * Scale.z;
    float pl = texture2D(BumpMap, gl_TexCoord[0].xy - dx).r * Scale.z;
    float pr = texture2D(BumpMap, gl_TexCoord[0].xy + dx).r * Scale.z;
    float pu = texture2D(BumpMap, gl_TexCoord[0].xy - dy).r * Scale.z;
    float pd = texture2D(BumpMap, gl_TexCoord[0].xy + dy).r * Scale.z;

    vec3 s;
    s  = normalize(vec3(pu-pc, pc-pl, 1.0));
    s += normalize(vec3(pc-pd, pc-pl, 1.0));
    s += normalize(vec3(pc-pd, pr-pc, 1.0));
    s += normalize(vec3(pu-pc, pr-pc, 1.0));

    s = normalize(s);

    gl_FragColor.rgb = s * 0.5 + 0.5;
    //gl_FragColor.rg = s.rg * 0.5 + 0.5;
    //gl_FragColor.b = clamp(1.0 - pow(s.b, 6.0), 0.0, 1.0);
    gl_FragColor.a = h;
}

#endif
