uniform sampler2D   Tex;
uniform vec2        Size;

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

// compress a 4x4 block to DXT1 format
// integer version, renders to 2 x int32 buffer
void main()
{
    // read block
    vec3 block[16];
    ExtractColorBlockRGB(block, Tex, gl_TexCoord[0].xy, Size);

    // find min and max colors
    vec3 mincol, maxcol;
    FindMinMaxColorsBox(block, mincol, maxcol);

    SelectDiagonal(block, mincol, maxcol);

    InsetBBox(mincol, maxcol);

    gl_FragColor.x = EmitEndPointsDXT1(mincol, maxcol);
    gl_FragColor.w = EmitIndicesDXT1(block, mincol, maxcol);
}

#endif
