#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect   Tex;
uniform vec2 Offset[16];

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

void main()
{
    vec4  Color;
    float summary = 0.0;
    float maximum = 0.0;
    for (int i=0; i<16; i++)
    {
        Color = texture2DRect(Tex, gl_TexCoord[0].xy + Offset[i]);
        maximum = max(maximum, Color.g);
        summary += Color.r;
    }

    gl_FragColor = max(summary * 0.0625, maximum, 0.0, 0.0);
}

#endif
