#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect   Tex;
uniform vec2 Offset[16];

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

void main()
{
    vec4 Color = vec4(0.0);
    for (int i=0; i<16; i++)
        Color += texture2DRect(Tex, gl_TexCoord[0].xy + Offset[i]);
    Color *= 0.0625;
/*
    float BrightMin = 0.7;
    float Bright = dot(Color.rgb, vec3(0.3, 0.59, 0.11));
    if (Bright <= BrightMin) Color.rgb *= pow(Bright / BrightMin, 8.0);
*/
    gl_FragColor = Color;
}

#endif
