#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect   Base;
uniform sampler2DRect   Bloom;
uniform vec4            Param; // (BloomBright, BloomTextureResolution, Exposure, MaxBright)

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

void main()
{
    vec4 Color = texture2DRect(Base, gl_TexCoord[0].xy);
    Color.rgb += texture2DRect(Bloom, gl_TexCoord[0].xy * Param.y).rgb * Param.x;

    //gl_FragColor.rgb = Color.rgb;

    gl_FragColor.rgb = 1.0 - exp(-Param.z * Color.rgb);

    //const float fGaussianScalar = 1.0;
    //float Lp = (1.0 / Param.z) * max(Color.r, max(Color.g, Color.b));
    //float Lm = Param.w + fGaussianScalar * Param.w;
    //float toneScalar = Lp * (1.0 +  Lp/(Lm*Lm)) / (1.0 + Lp);
    //gl_FragColor.rgb = Color.rgb * toneScalar;

    //Color.rgb *= Param.z;
    //gl_FragColor.r = Color.r < 1.413 ? pow(Color.r * 0.38317, 1.0 / 2.2) : 1.0 - exp(-Color.r);
    //gl_FragColor.g = Color.g < 1.413 ? pow(Color.g * 0.38317, 1.0 / 2.2) : 1.0 - exp(-Color.g);
    //gl_FragColor.b = Color.b < 1.413 ? pow(Color.b * 0.38317, 1.0 / 2.2) : 1.0 - exp(-Color.b);

    gl_FragColor.a = Color.a;
}

#endif
