#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect   Base;
uniform sampler2DRect   Bloom;
uniform vec4            Param; // (BaseBright, BloomBright, Exposure, BloomTextureResolution)

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

void main()
{
    vec4 BaseColor  = texture2DRect(Base, gl_TexCoord[0].xy);
    vec4 BloomColor = texture2DRect(Bloom, gl_TexCoord[0].xy * Param.w);

#if 0
    // 0.95 version bloom
    gl_FragColor.rgb = BaseColor.rgb * Param.x + BloomColor.rgb * Param.y;
#else
    // 0.96 version bloom
    BloomColor.rgb = max(BloomColor.rgb - vec3(0.9), vec3(0.0));
    gl_FragColor.rgb = BaseColor.rgb + BloomColor.rgb * Param.y;
#endif

    gl_FragColor.rgb = 1.0 - exp(-Param.z * gl_FragColor.rgb);
    gl_FragColor.a = sqrt(dot(gl_FragColor.rgb, vec3(0.299, 0.587, 0.114))); // compute luma
}

#endif
