//attribute  vec4  gl_Color;            // color
//attribute  vec4  gl_Vertex;           // vertex world position

uniform vec4      Clip;         // (Center, Radius^2)

#ifdef _VERTEX_

out vec3  Vertex;
out vec4  Color;

void main()
{
    Vertex = gl_Vertex.xyz;
    Color = gl_Color;
    gl_Position = gl_ProjectionMatrix * gl_Vertex;
}

#else

in vec3  Vertex;
in vec4  Color;

void main()
{
    vec3  Vector = Vertex - Clip.xyz;
    float Dist2 = dot(Vector, Vector);
    float fade = clamp((Clip.w - Dist2) * 100.0, 0.0, 1.0);
    gl_FragColor = Color * fade;
}

#endif
