uniform samplerCube CubeMap;
uniform vec4        Param;      // (Aspect, LensAngle, CutOff, 0)
uniform vec4        BackColor;
uniform vec3        Offset;

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

void main()
{
    vec2  p = -vec2(Param.x * gl_TexCoord[0].y, gl_TexCoord[0].x);
    float r = length(p);
    if (r > Param.z)
        gl_FragColor = BackColor;
    else
    {
        float Angle = Param.y * r;
        float sinr = sin(Angle) / r;
        vec3  ray = vec3(cos(Angle), sinr * p.x, sinr * p.y);
        gl_FragColor = textureCube(CubeMap, ray + Offset);
    }
}

#endif
