//attribute float gl_Vertex;          // Sprite center world position
//attribute float gl_MultiTexCoord0;  // Luminosity
//attribute float gl_Color;           // Color index

uniform sampler1D ColorMap;
uniform vec4      Param;    // StarBrightCoef, StarBrightMin, StarParticleSize, StarPointParticleFadeOut

#ifdef _VERTEX_

out vec2 ColBright;

void main()
{
    vec4 viewPos = gl_ModelViewMatrix * gl_Vertex;
    gl_Position = gl_ProjectionMatrix * viewPos;

    float Dist2 = dot(viewPos.xyz, viewPos.xyz);
    float mag = (exp(gl_MultiTexCoord0.x) / Dist2) * Param.x;

    ColBright.x = gl_Color.x;
    ColBright.y = clamp(Param.w * (mag - Param.y), 0.0, 1.0) * clamp(mag, 1.0, 2.5);

    if (mag > 1.0)  mag = 1.0 + log(mag);
    gl_PointSize = Param.z * sqrt(mag);
}

#else

in vec2 ColBright;

void main()
{
    gl_FragColor.rgb = ColBright.y * texture1D(ColorMap, ColBright.x).rgb;
    gl_FragColor.a = 1.0;
}

#endif
