#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect   Scene;
uniform sampler2D       Texture;
uniform vec4            Param1; // (SunPosX, SunPosY, 1/fbo.width, 1/FlareTexture.width)
uniform vec4            Param2; // (Radius, Step, Bright, Scale)

#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

void main()
{
    vec2 flareTC = gl_TexCoord[0].xy * Param1.z;

    vec4  scene  = texture2DRect(Scene, Param1.xy);
    float bright = dot(scene.rgb, vec3(0.333));
    if (bright > 1.0) scene.rgb /= bright;
    vec3  flare  = texture2D(Texture,  flareTC).rgb;
    gl_FragColor.rgb = flare * scene.rgb * clamp(1.0 - scene.a, 0.0, 1.0) * Param2.z;
    gl_FragColor.a = 0.0;

    //gl_FragColor.rgb = texture2DRect(Scene, Param1.xy + (flareTC - vec2(0.5)) * Param2.w * 64).rgb;
    //gl_FragColor.a = 1.0;
}

#endif
