#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

vec4    ColorMapAsteroid(vec3 point, float height, float slope)
{
    noiseOctaves = 2.0;
    height = DistFbm((point + Randomize) * 3.7, 1.5) * 0.7 + 0.5;

    //float vary = 4.0 * abs(Fbm(point * 150 * colorDistFreq));
    noiseOctaves = 8.0;
    vec3 p = point * 10.0 * colorDistFreq;
    p += FbmVec3(p);
    float vary = Cell2Noise(p) * 4.0;

    //vec4 color = GetSurfaceColorAtlas(height, slope, vary);
    vec4 color = GetSurfaceColorAtlasSmooth(height, slope, vary);

    //color.rgb *= 0.2 + slope * 3.0;
    color.rgb *= 0.5 + slope;
    return color;
}

void main()
{
    vec3  point = GetSurfacePoint();
    vec2  texCoord = gl_TexCoord[0].xy * scaleParams.z + scaleParams.xy;
    vec4  bumpData = texture2D(NormalMap, texCoord);
    vec3  norm = 2.0 * bumpData.xyz - 1.0;
    float slope = clamp(1.0 - pow(norm.z, 6.0), 0.0, 1.0);
    gl_FragColor = ColorMapAsteroid(point, bumpData.w, slope);
}

#endif
