#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

vec4    ColorMapClouds(vec3 point, float height)
{
    float  alpha = saturate(3.0 * (height + cloudsCoverage));
    return alpha * GetCloudsColor(height);
}

void main()
{
    vec3  point = GetSurfacePoint();
    vec2  texCoord = gl_TexCoord[0].xy * scaleParams.z + scaleParams.xy;
    vec4  bumpData = texture2D(NormalMap, texCoord);
    gl_FragColor = ColorMapClouds(point, bumpData.w);
}

#endif
