#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

float   HeightMapCloudsGasGiant(vec3 point)
{
    vec3  twistedPoint = point;
    float offset = 0.0;
    //float zone = cos(point.y * twistZones);
    //zone = zone*zone*zone;
    //zone = atan(zone*2.0) * 2.0/pi;
    float zone = Noise(vec3(0.0, point.y * twistZones * 0.5, 0.0)) * 2.0;
    noiseOctaves = 99.9;

    // Compute cyclons
    if (cycloneOctaves > 0.9)
    {
        vec4 cyclone = CycloneNoise(point);
        twistedPoint = cyclone.xyz;
        offset = cyclone.w;
    }

    // Compute stripes
    float turbulence, height;
    if (cloudsStyle == 0.0)
    {
        float ang = zone * twistMagn;
        float sina = sin(ang);
        float cosa = cos(ang);
        twistedPoint = vec3(cosa*twistedPoint.x-sina*twistedPoint.z, twistedPoint.y, sina*twistedPoint.x+cosa*twistedPoint.z);
        twistedPoint = twistedPoint * mainFreq + Randomize;
        turbulence = Fbm(colorDistFreq * twistedPoint);
        twistedPoint *= 666.0 + 5.0 * turbulence;
        height = (Fbm(twistedPoint) + 0.7) * 0.7;
    }
    else
    {
        turbulence = Fbm(twistedPoint * 0.05);
        twistedPoint = twistedPoint * mainFreq + Randomize;
        twistedPoint.y *= 735.0 + turbulence * twistMagn;
        height = (Fbm(twistedPoint) + 0.7) * 0.7;
    }

    return 0.5*(0.5+0.6*zone) + colorDistMagn * height + offset;
}

void main()
{
    vec3  point = GetSurfacePoint();
    float height = HeightMapCloudsGasGiant(point);
    gl_FragColor = vec4(height);
}

#endif
