#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

float   HeightMapSun(vec3 point)
{
    // Get global landscape
    noiseOctaves = 6.0;
    float global = clamp(DistFbm(point * mainFreq + Randomize, 1.5) * 0.5 + 0.5, 0.0, 1.0) * 0.1 + 0.3;

    // Get solar spots
    if (mareSqrtDensity >= 0.05)
    {
        noiseOctaves = 5;
        global = SolarSpotsNoise(point, global);
    }

    // Get granularity
    noiseOctaves = 5;
    vec3 p = point * colorDistFreq + Randomize;
    vec3 dist = colorDistMagn * FbmVec3(p * 0.2);
    vec2 cell = Cell3Noise2(p + dist);
    //float gran = 0.5 * smoothstep(0.0, 0.4, cell.y - cell.x);
    //float gran = 0.5 * sqrt(abs(cell.y - cell.x));
    float gran = 0.7 * smoothstep(0.1, 1.0, sqrt(abs(cell.y - cell.x)));

    return global + gran;
}

void main()
{
    vec3  point = GetSurfacePoint();
    float height = HeightMapSun(point);
    gl_FragColor = vec4(height);
}

#endif
